Index: less/cmdbuf.c
diff -u less/cmdbuf.c:1.1.1.9 less/cmdbuf.c:1.25
--- less/cmdbuf.c:1.1.1.9	Sun Dec  1 05:40:46 1996
+++ less/cmdbuf.c	Sun Jan 12 18:15:25 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -41,6 +44,11 @@
 static char *cp;		/* Pointer into cmdbuf */
 static int cmd_offset;		/* Index into cmdbuf of first displayed char */
 static int literal;		/* Next input char should not be interpreted */
+static CHARSET cmdcs[CMDBUF_SIZE]; /* Buffer for holding a CHARSET of cmdbuf */
+static CHARSET *csp;		/* Pointer into cmdcs */
+#if ISO
+static MULBUF *mp = NULL;
+#endif
 
 #if TAB_COMPLETE_FILENAME
 static int cmd_complete();
@@ -73,6 +81,7 @@
 	struct mlist *prev;
 	struct mlist *curr_mp;
 	char *string;
+	CHARSET *charset;
 };
 
 /*
@@ -110,6 +119,25 @@
 
 
 /*
+ * Count the width of strings.
+ */
+	static int
+strwidth(s, cs)
+	char *s;
+	CHARSET cs;
+{
+#if ISO
+	int w = 0;
+
+	while (*s != '\0')
+		w += mwidth(*s++, cs);
+	return (w);
+#else
+	return (strlen(s));
+#endif
+}
+
+/*
  * Reset command buffer (to empty).
  */
 	public void
@@ -117,9 +145,23 @@
 {
 	cp = cmdbuf;
 	*cp = '\0';
+	csp = cmdcs;
 	cmd_col = 0;
 	cmd_offset = 0;
 	literal = 0;
+#if ISO
+	if (mp == NULL)
+	{
+		char *s = NULL;
+		mp = new_multi();
+		s = getenv("JLESSKEYCHARSET");
+		if (s == NULL)
+			s = DEFKEYCHARSET;
+		set_codesets(mp, left_codeset_of_charset(s),
+			     right_codeset_of_charset(s));
+	}
+	prewind_multi(mp, -1);
+#endif
 }
 
 /*
@@ -140,8 +182,8 @@
 	char *s;
 {
 	putstr(s);
-	cmd_col += strlen(s);
-	prompt_col += strlen(s);
+	cmd_col += strwidth(s, ASCII);
+	prompt_col += strwidth(s, ASCII);
 }
 
 /*
@@ -167,13 +209,13 @@
 	 * Repaint the line from the current position.
 	 */
 	clear_eol();
-	for ( ;  *cp != '\0';  cp++)
+	for ( ;  *cp != '\0';  cp++, csp++)
 	{
-		p = prchar(*cp);
-		if (cmd_col + strlen(p) >= sc_width)
+		p = prchar(*cp, *csp);
+		if (cmd_col + strwidth(p, *csp) >= sc_width)
 			break;
-		putstr(p);
-		cmd_col += strlen(p);
+		putmchrs(p, *csp);
+		cmd_col += strwidth(p, *csp);
 	}
 
 	/*
@@ -197,6 +239,7 @@
 	}
 
 	cp = &cmdbuf[cmd_offset];
+	csp = &cmdcs[cmd_offset];
 }
 
 /*
@@ -206,6 +249,7 @@
 cmd_lshift()
 {
 	char *s;
+	CHARSET *t;
 	char *save_cp;
 	int cols;
 
@@ -214,9 +258,10 @@
 	 * right we'd have to move to reach the center of the screen.
 	 */
 	s = cmdbuf + cmd_offset;
-	cols = 0;
-	while (cols < (sc_width - prompt_col) / 2 && *s != '\0')
-		cols += strlen(prchar(*s++));
+	t = cmdcs + cmd_offset;
+	for (cols = 0; cols < (sc_width - prompt_col) / 2 && *s != '\0';
+	     s++, t++)
+		cols += strwidth(prchar(*s, *t), *t);
 
 	cmd_offset = s - cmdbuf;
 	save_cp = cp;
@@ -231,6 +276,7 @@
 cmd_rshift()
 {
 	char *s;
+	CHARSET *t;
 	char *p;
 	char *save_cp;
 	int cols;
@@ -241,11 +287,12 @@
 	 * of displayed characters.
 	 */
 	s = cmdbuf + cmd_offset;
+	t = cmdcs + cmd_offset;
 	cols = 0;
 	while (cols < (sc_width - prompt_col) / 2 && s > cmdbuf)
 	{
-		p = prchar(*--s);
-		cols += strlen(p);
+		p = prchar(*--s, *--t);
+		cols += strwidth(p, *t);
 	}
 
 	cmd_offset = s - cmdbuf;
@@ -262,6 +309,9 @@
 {
 	char *p;
 	
+#if ISO
+	do {
+#endif
 	if (*cp == '\0')
 	{
 		/* 
@@ -269,14 +319,18 @@
 		 */
 		return (CC_OK);
 	}
-	p = prchar(*cp);
-	if (cmd_col + strlen(p) >= sc_width)
+	p = prchar(*cp, *csp);
+	if (cmd_col + strwidth(p, *csp) >= sc_width)
 		cmd_lshift();
-	else if (cmd_col + strlen(p) == sc_width - 1 && cp[1] != '\0')
+	else if (cmd_col + strwidth(p, *csp) == sc_width - 1 && cp[1] != '\0')
 		cmd_lshift();
+	putmchrs(p, *csp);
+	cmd_col += strwidth(p, *csp);
 	cp++;
-	putstr(p);
-	cmd_col += strlen(p);
+	csp++;
+#if ISO
+	} while (CSISREST(*csp));
+#endif
 	return (CC_OK);
 }
 
@@ -288,18 +342,25 @@
 {
 	char *p;
 	
+#if ISO
+	do {
+#endif
 	if (cp <= cmdbuf)
 	{
 		/* Already at the beginning of the line */
 		return (CC_OK);
 	}
-	p = prchar(cp[-1]);
-	if (cmd_col < prompt_col + strlen(p))
+	p = prchar(cp[-1], csp[-1]);
+	if (cmd_col < prompt_col + strwidth(p, csp[-1]))
 		cmd_rshift();
 	cp--;
-	cmd_col -= strlen(p);
+	csp--;
+	cmd_col -= strwidth(p, *csp);
 	while (*p++ != '\0')
 		putbs();
+#if ISO
+	} while (CSISREST(*csp));
+#endif
 	return (CC_OK);
 }
 
@@ -311,8 +372,13 @@
 	int c;
 {
 	char *s;
+	CHARSET *t;
 	
+#if ISO
+	if (strlen(cmdbuf) >= sizeof(cmdbuf)-5)
+#else
 	if (strlen(cmdbuf) >= sizeof(cmdbuf)-2)
+#endif
 	{
 		/*
 		 * No room in the command buffer for another char.
@@ -324,9 +390,44 @@
 	/*
 	 * Insert the character into the buffer.
 	 */
-	for (s = &cmdbuf[strlen(cmdbuf)];  s >= cp;  s--)
+#if ISO
+	if (in_mca())
+	{
+		char *cbuf;
+		CHARSET *csbuf;
+		int i, j;
+
+		buffering_multi(mp, c, &cbuf, &csbuf, &i);
+		if (i > 0)
+			for ((s = &cmdbuf[strlen(cmdbuf)]),
+			     t = &cmdcs[strlen(cmdbuf)];  s >= cp;  s--, t--)
+			{
+				s[i] = s[0];
+				t[i] = t[0];
+			}
+		for (j = 0; j < i; j++)
+		{
+			cp[j] = cbuf[j];
+			csp[j] = csbuf[j];
+		}
+		cbuf = &cp[i];
+		/*
+		 * Reprint the tail of the line from the inserted char.
+		 */
+		cmd_repaint(cp);
+		while (cp < cbuf)
+			cmd_right();
+		return (CC_OK);
+	}
+#endif
+	for ((s = &cmdbuf[strlen(cmdbuf)]), t = &cmdcs[strlen(cmdbuf)];
+	     s >= cp;  s--, t--)
+	{
 		s[1] = s[0];
+		t[1] = t[0];
+	}
 	*cp = c;
+	*csp = ASCII;
 	/*
 	 * Reprint the tail of the line from the inserted char.
 	 */
@@ -343,6 +444,8 @@
 cmd_erase()
 {
 	register char *s;
+	register CHARSET *t;
+	int num;
 
 	if (cp == cmdbuf)
 	{
@@ -355,12 +458,17 @@
 	/*
 	 * Move cursor left (to the char being erased).
 	 */
+	s = cp;
 	cmd_left();
+	num = s - cp;
 	/*
 	 * Remove the char from the buffer (shift the buffer left).
 	 */
-	for (s = cp;  *s != '\0';  s++)
-		s[0] = s[1];
+	for ((s = cp), t = csp;  *s != '\0';  s++, t++)
+	{
+		s[0] = s[num];
+		t[0] = t[num];
+	}
 	/*
 	 * Repaint the buffer after the erased char.
 	 */
@@ -498,6 +606,8 @@
 	int action;
 {
 	char *s;
+	CHARSET *t;
+	int i;
 	
 	if (curr_mlist == NULL)
 	{
@@ -520,14 +630,17 @@
 	 * Copy the entry into cmdbuf and echo it on the screen.
 	 */
 	s = curr_mlist->curr_mp->string;
+	t = curr_mlist->curr_mp->charset;
 	if (s == NULL)
 		s = "";
-	for (cp = cmdbuf;  *s != '\0';  s++)
+	for ((cp = cmdbuf), (csp = cmdcs), i = 0;  *s != '\0';  s++, t++, i++)
 	{
-		*cp = *s;
-		cmd_right();
+		cp[i] = *s;
+		csp[i] = *t;
 	}
-	*cp = '\0';
+	cp[i] = '\0';
+	while (*cp != '\0')
+		cmd_right();
 	return (CC_OK);
 }
 #endif
@@ -569,6 +682,9 @@
 		 */
 		ml = (struct mlist *) ecalloc(1, sizeof(struct mlist));
 		ml->string = save(cmdbuf);
+		ml->charset = (CHARSET *)
+			ecalloc(strlen(cmdbuf), sizeof(CHARSET));
+		memcpy(ml->charset, cmdcs, strlen(cmdbuf) * sizeof(CHARSET));
 		ml->next = curr_mlist;
 		ml->prev = curr_mlist->prev;
 		curr_mlist->prev->next = ml;
@@ -1023,4 +1139,13 @@
 get_cmdbuf()
 {
 	return (cmdbuf);
+}
+
+/*
+ * Return a pointer to the character set bufffer of the command buffer.
+ */
+	public CHARSET *
+get_cmdcs()
+{
+	return (cmdcs);
 }
Index: less/command.c
diff -u less/command.c:1.1.1.11 less/command.c:1.16
--- less/command.c:1.1.1.11	Sun Dec  1 05:40:47 1996
+++ less/command.c	Sun Jan 12 18:15:26 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -152,15 +155,17 @@
 exec_mca()
 {
 	register char *cbuf;
+	CHARSET *csbuf;
 
 	cmd_exec();
 	cbuf = get_cmdbuf();
+	csbuf = get_cmdcs();
 
 	switch (mca)
 	{
 	case A_F_SEARCH:
 	case A_B_SEARCH:
-		multi_search(cbuf, number);
+		multi_search(cbuf, csbuf, number);
 		break;
 	case A_FIRSTCMD:
 		/*
@@ -593,8 +598,9 @@
  * If SRCH_PAST_EOF is set, continue the search thru multiple files.
  */
 	static void
-multi_search(pattern, n)
+multi_search(pattern, charset, n)
 	char *pattern;
+	CHARSET *charset;
 	int n;
 {
 	register int nomore;
@@ -625,7 +631,7 @@
 
 	for (;;)
 	{
-		n = search(search_type, pattern, n);
+		n = search(search_type, pattern, charset, n);
 		/*
 		 * The SRCH_NO_MOVE flag doesn't "stick": it gets cleared
 		 * after being used once.  This allows "n" to work after
@@ -1056,7 +1062,7 @@
 #define	DO_SEARCH()	if (number <= 0) number = 1;	\
 			mca_search();			\
 			cmd_exec();			\
-			multi_search((char *)NULL, number);
+			multi_search((char *)NULL, (CHARSET *)NULL, number);
 
 
 		case A_F_SEARCH:
@@ -1359,6 +1365,16 @@
 			}
 			c = getcc();
 			goto again;
+
+#if JAPANESE
+		case A_ROT_RCODESET:
+			parg.p_string =
+				rotate_right_codeset(get_mulbuf(curr_ifile));
+			screen_trashed = 1;
+			make_display();
+			error("%s codeset is used in right plane", &parg);
+			break;
+#endif
 
 		case A_NOACTION:
 			break;
Index: less/decode.c
diff -u less/decode.c:1.1.1.11 less/decode.c:1.14
--- less/decode.c:1.1.1.11	Sun Dec  1 05:40:47 1996
+++ less/decode.c	Sun Jan 12 18:15:26 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -154,6 +157,10 @@
 	'v',0,				A_VISUAL,
 	'!',0,				A_SHELL,
 	'+',0,				A_FIRSTCMD,
+
+#if JAPANESE
+	'@',0,				A_ROT_RCODESET,
+#endif
 
 	'H',0,				A_HELP,
 	'h',0,				A_HELP,
Index: less/defines.ds
diff -u less/defines.ds:1.1.1.1 less/defines.ds:1.5
--- less/defines.ds:1.1.1.1	Sun Dec  1 05:41:22 1996
+++ less/defines.ds	Sun Jan 12 18:15:27 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -187,6 +190,46 @@
  * HAVE_DUP is 1 if your system has the dup() call.
  */
 #define	HAVE_DUP	1
+
+/*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"sjis-jis"
 
 /*
  * Sizes of various buffers.
Index: less/defines.h.in
diff -u less/defines.h.in:1.1.1.10 less/defines.h.in:1.23
--- less/defines.h.in:1.1.1.10	Sun Dec  1 05:41:14 1996
+++ less/defines.h.in	Sat Jan 11 01:27:03 1997
@@ -158,6 +158,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
Index: less/defines.h.top
diff -u less/defines.h.top:1.1.1.8 less/defines.h.top:1.21
--- less/defines.h.top:1.1.1.8	Sun Dec  1 05:41:15 1996
+++ less/defines.h.top	Sat Jan 11 01:27:04 1997
@@ -157,6 +157,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
Index: less/defines.o2
diff -u less/defines.o2:1.1.1.1 less/defines.o2:1.5
--- less/defines.o2:1.1.1.1	Sun Dec  1 05:41:23 1996
+++ less/defines.o2	Sun Jan 12 18:16:09 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -167,6 +170,46 @@
  * HAVE_DUP is 1 if your system has the dup() call.
  */
 #define	HAVE_DUP	1
+
+/*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese"
 
 /*
  * Sizes of various buffers.
Index: less/defines.o9
diff -u less/defines.o9:1.1.1.2 less/defines.o9:1.6
--- less/defines.o9:1.1.1.2	Sun Dec  1 05:41:24 1996
+++ less/defines.o9	Sun Jan 12 18:16:10 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -180,6 +183,46 @@
  * HAVE_DUP is 1 if your system has the dup() call.
  */
 #define	HAVE_DUP 0
+
+/*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese"
 
 /*
  * Sizes of various buffers.
Index: less/defines.wn
diff -u less/defines.wn:1.1.1.1 less/defines.wn:1.5
--- less/defines.wn:1.1.1.1	Sun Dec  1 05:41:25 1996
+++ less/defines.wn	Sun Jan 12 18:16:10 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -168,6 +171,46 @@
  * HAVE_DUP is 1 if your system has the dup() call.
  */
 #define	HAVE_DUP	1
+
+/*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"sjis-jis"
 
 /*
  * Sizes of various buffers.
Index: less/filename.c
diff -u less/filename.c:1.1.1.10 less/filename.c:1.16
--- less/filename.c:1.1.1.10	Sun Dec  1 05:40:49 1996
+++ less/filename.c	Sun Jan 12 18:16:11 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of compress file treating routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -769,6 +772,25 @@
 	return (gfilename);
 }
 
+#if COMPRESS
+/*
+ * Check a name of input file and easy execution some uncompressing program.
+ */
+	static char*
+easy_lessopen_for_zcatfile(filename)
+	register char *filename;
+{
+	register int length = strlen(filename);
+
+	if (strcmp(".Z", &filename[length - 2]) == 0 ||
+	    strcmp(".z", &filename[length - 2]) == 0 ||
+	    strcmp(".gz", &filename[length - 3]) == 0)
+		return ("| zcat %s");
+	else
+		return (NULL);
+}
+#endif
+
 /*
  * See if we should open a "replacement file" 
  * instead of the file we're about to open.
@@ -794,6 +816,9 @@
 		return (NULL);
 	ch_ungetchar(-1);
 	if ((lessopen = lgetenv("LESSOPEN")) == NULL)
+#if COMPRESS
+	    if ((lessopen = easy_lessopen_for_zcatfile(filename)) == NULL)
+#endif
 		return (NULL);
 	if (strcmp(filename, "-") == 0)
 		return (NULL);
Index: less/funcs.h
diff -u less/funcs.h:1.1.1.10 less/funcs.h:1.29
--- less/funcs.h:1.1.1.10	Sun Dec  1 05:41:10 1996
+++ less/funcs.h	Sat Jan 11 01:27:06 1997
@@ -47,9 +47,12 @@
 	public void ch_close ();
 	public int ch_getflags ();
 	public void ch_dump ();
+	public CODESET left_codeset_of_charset ();
+	public CODESET right_codeset_of_charset ();
 	public void init_charset ();
 	public int binary_char ();
 	public int control_char ();
+	public void change_control_char ();
 	public char * prchar ();
 	public void cmd_reset ();
 	public void clear_cmd ();
@@ -60,6 +63,7 @@
 	public int cmd_char ();
 	public int cmd_int ();
 	public char * get_cmdbuf ();
+	public CHARSET * get_cmdcs ();
 	public int in_mca ();
 	public void dispversion ();
 	public int getcc ();
@@ -121,6 +125,7 @@
 	public void store_pos ();
 	public void get_pos ();
 	public void set_open ();
+	public MULBUF * get_mulbuf ();
 	public int opened ();
 	public void hold_ifile ();
 	public int held_ifile ();
@@ -167,6 +172,7 @@
 	public void opt__P ();
 	public void opt_b ();
 	public void opt_i ();
+	public void opt_Z ();
 	public void opt__V ();
 	public void opt_D ();
 	public void opt_quote ();
@@ -191,8 +197,13 @@
 	public int  isatty ();
 	public void put_line ();
 	public void flush ();
+	public int putchr_raw ();
+	public void putstr_raw ();
 	public int putchr ();
 	public void putstr ();
+	public int putmchr ();
+	public int putmchrs ();
+	public void putmstr ();
 	public void get_return ();
 	public void error ();
 	public void ierror ();
@@ -207,6 +218,25 @@
 	public int empty_lines ();
 	public void get_scrpos ();
 	public int adjsline ();
+	public void set_planeset ();
+	public void init_multi ();
+	public void init_def_priority ();
+	public void init_priority ();
+	public CODESET get_priority ();
+	public void set_priority ();
+	public MULBUF * new_multi ();
+	public void prewind_multi ();
+	public void buffering_multi ();
+	public void parsing_multi ();
+	public void pdone_multi ();
+	public void set_codesets ();
+	public int get_bufbytes ();
+	public void set_bufbytes ();
+	public char * get_icharset_string ();
+	public char * outchar();
+	public char * outbuf();
+	public int mwidth();
+	public char * rotate_right_codeset ();
 	public void init_prompt ();
 	public char * pr_expand ();
 	public char * eq_message ();
Index: less/ifile.c
diff -u less/ifile.c:1.1.1.8 less/ifile.c:1.11
--- less/ifile.c:1.1.1.8	Sun Dec  1 05:40:51 1996
+++ less/ifile.c	Sun Jan 12 18:16:11 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -49,6 +52,7 @@
 	int h_hold;			/* Hold count */
 	char h_opened;			/* Has this ifile been opened? */
 	struct scrpos h_scrpos;		/* Saved position within the file */
+	MULBUF *h_mp;			/* MULBUF for multi bytes character */
 };
 
 /*
@@ -128,6 +132,9 @@
 	p->h_opened = 0;
 	p->h_hold = 0;
 	p->h_filestate = NULL;
+#if ISO
+	p->h_mp = new_multi();
+#endif
 	link_ifile(p, prev);
 	return (p);
 }
@@ -152,6 +159,9 @@
 	p = int_ifile(h);
 	unlink_ifile(p);
 	free(p->h_filename);
+#if ISO
+	free(p->h_mp);
+#endif
 	free(p);
 }
 
@@ -285,6 +295,20 @@
 	struct scrpos *scrpos;
 {
 	*scrpos = int_ifile(ifile)->h_scrpos;
+}
+
+/*
+ * Get the MULBUF associated with a ifile.
+ */
+	public MULBUF *
+get_mulbuf(ifile)
+	IFILE ifile;
+{
+#if ISO
+	if (ifile != NULL)
+		return (int_ifile(ifile)->h_mp);
+#endif
+	return (NULL);
 }
 
 /*
Index: less/input.c
diff -u less/input.c:1.1.1.6 less/input.c:1.18
--- less/input.c:1.1.1.6	Sat Sep 14 00:35:11 1996
+++ less/input.c	Sun Jan 12 18:16:12 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -45,6 +48,7 @@
 extern int hilite_search;
 extern int size_linebuf;
 #endif
+extern IFILE curr_ifile;
 
 /*
  * Get the next line.
@@ -85,7 +89,7 @@
 		return (NULL_POSITION);
 	}
 
-	prewind();
+	prewind(curr_pos);
 	plinenum(curr_pos);
 	(void) ch_seek(curr_pos);
 
@@ -129,19 +133,32 @@
 				do
 				{
 					c = ch_forw_get();
+#if ISO
+					/*
+					 * Parse all character for finding
+					 * escape sequences.
+					 */
+					parsing_multi(get_mulbuf(curr_ifile),
+						      c);
+#endif
 				} while (c != '\n' && c != EOI);
 				new_pos = ch_tell();
 				endline = 1;
 			} else
 			{
+#if ISO
+				new_pos = ch_tell() -
+					get_bufbytes(get_mulbuf(curr_ifile));
+#else
 				new_pos = ch_tell() - 1;
+#endif
 				endline = 0;
 			}
 			break;
 		}
 		c = ch_forw_get();
 	}
-	pdone(endline);
+	pdone(endline, new_pos);
 
 	if (squeeze && blankline)
 	{
@@ -276,7 +293,7 @@
 	endline = 0;
     loop:
 	begin_new_pos = new_pos;
-	prewind();
+	prewind(new_pos);
 	plinenum(new_pos);
 	(void) ch_seek(new_pos);
 
@@ -306,14 +323,24 @@
 				endline = 1;
 				break;
 			}
-			pdone(0);
+#if ISO
+			for (c = get_bufbytes(get_mulbuf(curr_ifile));
+			     --c >= 0; )
+			{
+				(void) ch_back_get();
+				new_pos--;
+			}
+			pdone(0, new_pos);
+#else
+			pdone(0, new_pos);
 			(void) ch_back_get();
 			new_pos--;
+#endif
 			goto loop;
 		}
 	} while (new_pos < curr_pos);
 
-	pdone(endline);
+	pdone(endline, new_pos);
 
 	return (begin_new_pos);
 }
Index: less/less.h
diff -u less/less.h:1.1.1.12 less/less.h:1.39
--- less/less.h:1.1.1.12	Sun Dec  1 05:41:11 1996
+++ less/less.h	Sat Jan 18 03:45:54 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -281,6 +284,103 @@
 #define	AT_BLINK	(3)
 #define	AT_INVIS	(4)
 #define	AT_STANDOUT	(5)
+
+
+/*
+ * Definition of values to specify the character set.
+ * And definitions some well known character sets and a types of set.
+ */
+typedef unsigned short CHARSET;
+
+#define	WRONG_CHAR		0x8000	/* Display this as binary characters */
+#define CSISWRONG(cs)		((cs) & WRONG_CHAR)
+
+#define	REST_MASK		0x4000	/* Rest bytes of character */
+#define CSISHEAD(cs)		(!((cs) & REST_MASK))
+#define CSISREST(cs)		((cs) & REST_MASK)
+
+#define IRR_MASK		0x3f00
+#define IRR_SHIFT		8
+#define CS2IRR(cs)		(((cs) & IRR_MASK) >> IRR_SHIFT)
+#define IRR2CS(irr)		(((irr) << IRR_SHIFT) & IRR_MASK)
+
+#define CODE_MASK		0x003f
+#define CODE_DIFF		0x0040
+#define IRR2CODE(irr)		((((irr) - 1) & CODE_MASK) + CODE_DIFF)
+#define CODE2IRR(code)		((((code) - CODE_DIFF) & CODE_MASK) + 1)
+
+#define TYPE_94_CHARSET		0x0000
+#define TYPE_96_CHARSET		0x0040
+#define TYPE_94N_CHARSET	0x0080
+#define TYPE_96N_CHARSET	0x00c0
+#define TYPE_MASK		0x00c0
+#define CS2TYPE(cs)		((cs) & TYPE_MASK)
+#define TYPE2CS(type)		((type) & TYPE_MASK)
+
+#define FT_MASK			0x003f
+#define FT_DIFF			0x0040
+#define CS2FT(cs)		(((cs) & FT_MASK) + FT_DIFF)
+#define FT2CS(ft)		(((ft) - FT_DIFF) & FT_MASK)
+
+#define CHARSET_MASK		(IRR_MASK | TYPE_MASK | FT_MASK)
+#define CS2CHARSET(cs)		((cs) & CHARSET_MASK)
+#define ISASCII(cs)		(CS2CHARSET(cs) == ASCII)
+
+#define ASCII			(TYPE_94_CHARSET | FT2CS('B'))
+#if ISO
+#define JISX0201KANA		(TYPE_94_CHARSET | FT2CS('I'))
+#define JISX0201ROMAN		(TYPE_94_CHARSET | FT2CS('J'))
+#define LATIN1			(TYPE_96_CHARSET | FT2CS('A'))
+#define LATIN2			(TYPE_96_CHARSET | FT2CS('B'))
+#define LATIN3			(TYPE_96_CHARSET | FT2CS('C'))
+#define LATIN4			(TYPE_96_CHARSET | FT2CS('D'))
+#define GREEK			(TYPE_96_CHARSET | FT2CS('F'))
+#define ARABIC			(TYPE_96_CHARSET | FT2CS('G'))
+#define HEBREW			(TYPE_96_CHARSET | FT2CS('H'))
+#define CYRILLIC		(TYPE_96_CHARSET | FT2CS('L'))
+#define LATIN5			(TYPE_96_CHARSET | FT2CS('M'))
+#define JISX0208_78KANJI	(TYPE_94N_CHARSET | FT2CS('@'))
+#define GB2312			(TYPE_94N_CHARSET | FT2CS('A'))
+#define JISX0208KANJI		(TYPE_94N_CHARSET | FT2CS('B'))
+#define JISX0208_90KANJI	(IRR2CS(1) | TYPE_94N_CHARSET | FT2CS('B'))
+#define KSC5601			(TYPE_94N_CHARSET | FT2CS('C'))
+#define JISX0212KANJISUP	(TYPE_94N_CHARSET | FT2CS('D'))
+
+#if JAPANESE
+/*
+ * Special number for Japanese code set.  Only input_set use following with
+ * above definitions.
+ */
+#define SJIS			(IRR2CS(1) | TYPE_94N_CHARSET | FT_MASK)
+#define UJIS			(IRR2CS(2) | TYPE_94N_CHARSET | FT_MASK)
+#endif
+#endif
+
+
+/*
+ * Definition of code sets.  The code set is not character set.
+ * It is only means of code, and we use these value when we
+ * decide what input data are.
+ */
+typedef enum {
+	/* code sets for left, right and output plane */
+	noconv,		/* A code set which doesn't need converting */
+	/* code sets for left and output plane */
+	jis,		/* JIS means a sub set of iso2022 */
+	iso7,		/* A code set which is extented by iso2022 */
+	/* code sets for only right plane */
+	none,		/* No code set */
+	japanese,	/* Both of UJIS and SJIS */
+	/* code sets for right and output plane */
+	ujis,		/* Japanese code set named UJIS */
+	sjis,		/* Japanese code set named SJIS */
+	iso8,		/* A code set which is extented by iso2022 */
+} CODESET;
+
+
+typedef struct multibuf MULBUF;
+
+
 
 #define	CONTROL(c)	((c)&037)
 #define	ESC		CONTROL('[')
Index: less/less.hlp
diff -u less/less.hlp:1.1.1.8 less/less.hlp:1.10
--- less/less.hlp:1.1.1.8	Sun Dec  1 05:41:21 1996
+++ less/less.hlp	Fri Jan 17 12:21:16 1997
@@ -70,6 +70,7 @@
   :p                *  Examine the (_N-th) previous file from the command line.
   :x                *  Examine the first (or _N-th) file from the command line.
   =  ^G  :f            Print current file name.
+  @                    Rotate the code recognition method of the current file.
   V                    Print version number of "less".
 
   -_<_f_l_a_g_>              Toggle a command line option [see OPTIONS below].
@@ -120,6 +121,7 @@
   -X            Don't use termcap init/deinit strings.
   -y [_N]        Forward scroll limit.
   -z [_N]        Set size of window.
+  -Z            Give priority to the SJIS over the UJIS if you use Japanese.
 
 
         ---------------------------------------------------
